# resource update date 03.04.2025
handle_error() {
    local error_msg=$1
    echo "IOPrint starting error: $error_msg"

    echo "kill all processes for $currentPath and free 8443 port"
    pkill -9 -f "$currentPath" 2>/dev/null
    sudo fuser -k 8443/tcp
    sleep 10

    if  test  -f "$oldPath"; then
        echo "$oldPath exists. IOprint rollback updating"
        echo "rename $oldPath to $currentPath"
        mv -f $oldPath $currentPath
    fi

    echo "run $currentPath"
    java -jar -Dspring.profiles.active=print $currentPath updating_error
    exit 1
}

downloadPath="ioprint_update.jar"
oldPath="ioprint_old.jar"
currentPath="ioprint.jar"
frpRunPath="frpRun.sh"
machineIdPath="/etc/machine-id"
lockFilePath="locknet"
pwd
if [ -s $machineIdPath ]; then
        # The file is not-empty.
        echo "$machineIdPath is not-empty."
        if [ -f $lockFilePath ]; then
                        # The file is created.
                        echo "Delete locknet und configure network"
                        sudo rm -r $lockFilePath
                        sudo dhcpcd -k
                        sudo dhcpcd
                        sudo shutdown -r now

                else
                        # The file is not-created.
                        echo "Network already configured"

                fi
else
        # The file is empty.
        echo "$machineIdPath is Empty. Create a machine-id"
        sudo dbus-uuidgen --ensure
        sudo systemd-machine-id-setup
        sudo shutdown -r now
fi
if  test  -f "$downloadPath"; then
    echo "$downloadPath exists. IOprint updating"
        if test -f "$oldPath"; then
                echo "$oldPath exists. Delete old file"
                rm $oldPath
        fi
        echo "rename $currentPath to $oldPath"
        mv $currentPath $oldPath
        echo "rename $downloadPath to $currentPath"
        mv $downloadPath $currentPath
        sudo shutdown -r now
fi
if test -f "$frpRunPath"; then
        echo "$frpRunPath exists. FRP checking"
        ./$frpRunPath
fi
echo "run $currentPath"
java -jar -Dspring.profiles.active=print $currentPath &

sleep 3

if [ $? -ne 0 ]; then
  handle_error "❌ Error run IOPrint"
fi
if ! pgrep -f $currentPath > /dev/null; then
  handle_error "❌ Process not found"
fi
sleep 30
if netstat -tuln | grep -q ":8443"; then
    echo "IOPrint listens 8443"
else
    handle_error "❌ IOPrint NOT listens 8443"
fi
echo "IOPrint started!"
